<?php
function fn_tagRelation()
{    
  global $configVal, $blog, $pluginURL, $entry;

	$data = setting::fetchConfigVal($configVal);
	$mother = $entry['id'];

	$context = Model_Context::getInstance();
	$blogid= $context->getProperty('blog.id');
	$blogURL = $context->getProperty('uri.blog');
	$database_prefix = $context->getProperty('database.prefix');
	$defaultURL = $context->getProperty('uri.default');
	$currentURL = (isset( $_SERVER["HTTPS"]) && $_SERVER['HTTPS']=='on' ? 'https://':'http://').$_SERVER['HTTP_HOST'].($_SERVER['SERVER_PORT']=='80' || $_SERVER['SERVER_PORT']=='443' ? '' : ':'.$_SERVER['SERVER_PORT']).$_SERVER['REQUEST_URI'];

	// modified by jeongki, Pat-al
	if(is_null($data)) {
		$data['tagListEa'] = 9;
		$data['cutString'] = 50;
		$data['sortType'] = 1;
		$data['commentView'] = 1;
		$data['rankIcon'] = 1;
		$data['tagComment'] = 1;
		$data['tagView'] = 0;
		$data['tagCount'] = 100;
		$data['tagHeader'] = '<fieldset class="tagrelation"><legend>얽힌 글타래</legend>';
		$data['tagFooter'] = '</fieldset>';
	}
  
  $data['tagListEa'] = ($data['tagListEa'])?" LIMIT 0, {$data['tagListEa']} ":"";  
  $tagIgnore = explode('|', $data['tagIgnore']);
  $tagIgnoreArray = array();
  $rowv = POD::queryAllWithDBCache("SELECT id FROM {$database_prefix}Tags WHERE name IN ('" . implode("', '", $tagIgnore) . "')");

  foreach($rowv as $rowresult) {
   $tagIgnoreArray[] = $rowresult[0];
  }

  $relationid = $mother;

 if ($relationid) {
  $rowv = POD::queryAllWithDBCache("SELECT A.tag FROM {$database_prefix}TagRelations A, {$database_prefix}Tags B
							           WHERE A.tag=B.id AND A.entry={$relationid} AND A.blogid = {$blogid} AND B.id NOT IN ('" . implode("', '", $tagIgnoreArray) . "')");

  foreach($rowv as $rowresult) {
    $tag_id .= $rowresult[0] . ',';
  }            
  
  if (is_null($tag_id)) {
  	$tag_id = '0';
  }
  else {
  	$tag_id = substr($tag_id,0,(strlen($tag_id) - 1));
  }    

  // modified by jeongki, Pat-al
	switch($data['sortType']) {
		case 1 :
			$row = POD::queryAllWithDBCache("SELECT B.id, B.title, B.slogan, COUNT(B.id) AS cnt, B.comments, B.visibility FROM {$database_prefix}TagRelations A, {$database_prefix}Entries B
											WHERE A.entry=B.id
											AND A.entry<>{$relationid}
											AND A.tag IN ({$tag_id})
											AND B.category >= 0
											AND B.id > 0
											AND B.blogid = {$blogid}
											AND B.visibility <> 0
											GROUP BY B.id
											ORDER BY cnt desc, RAND()
											{$data['tagListEa']}");
			break;
		case 2 :
			$row = POD::queryAllWithDBCache("SELECT B.id, B.title, B.slogan, B.published as published, B.comments, B.visibility FROM {$database_prefix}TagRelations A, {$database_prefix}Entries B
											WHERE A.entry=B.id											
											AND A.entry<>{$relationid}
											AND A.tag IN ({$tag_id})
											AND B.category >= 0
											AND B.id > 0
											AND B.blogid = {$blogid}
											AND B.visibility <> 0
											GROUP BY B.id
											ORDER BY published desc
											{$data['tagListEa']}");  		
			break;
		case 3 :
			$row = POD::queryAllWithDBCache("SELECT B.id, B.title, B.slogan, B.published as published, B.comments, B.visibility FROM {$database_prefix}TagRelations A, {$database_prefix}Entries B
											WHERE A.entry=B.id											
											AND A.entry<>{$relationid}
											AND A.tag IN ({$tag_id})
											AND B.category >= 0
											AND B.id > 0
											AND B.blogid = {$blogid}
											AND B.visibility <> 0
											GROUP BY B.id
											ORDER BY published asc
											{$data['tagListEa']}");  		
			break;
		case 4 :
			$row = POD::queryAllWithDBCache("SELECT B.id, B.title, B.slogan, B.published, B.comments, B.visibility FROM {$database_prefix}TagRelations A, {$database_prefix}Entries B
											WHERE A.entry=B.id											
											AND A.entry<>{$relationid}
											AND A.tag IN ({$tag_id})
											AND B.category >= 0
											AND B.id > 0
											AND B.blogid = {$blogid}
											AND B.visibility <> 0
											GROUP BY B.id
											ORDER BY RAND()
											{$data['tagListEa']}");  		
			break;
		default :
			$row = POD::queryAllWithDBCache("SELECT B.id, B.title, B.slogan, COUNT(B.id) AS cnt, B.comments, B.visibility FROM {$database_prefix}TagRelations A, {$database_prefix}Entries B
											WHERE A.entry=B.id
											AND A.entry<>{$relationid}
											AND A.tag IN ({$tag_id})
											AND B.category >= 0
											AND B.id > 0
											AND B.blogid = {$blogid}
											AND B.visibility <> 0
											GROUP BY B.id
											ORDER BY cnt desc, RAND()
											{$data['tagListEa']}");  		
			break;
	}
  
  $tagrelation .= $data['tagHeader'] . "<ul>";
  $i = 0;

  foreach($row as $result) {
  	if ($result[5] == 0) continue;
		$i++;
	 	$r_id  = $result[0];
	 	
	// modified by jeongki, Pat-al
 	// 어떤 보람말(태그)과 연결이 되어 있는지
		$r_row = POD::queryAllWithDBCache("SELECT A.tag, B.name, COUNT(tag) AS tagcount FROM 
                            {$database_prefix}TagRelations A, {$database_prefix}Tags B
                            WHERE (A.entry={$relationid} AND A.tag=B.id AND B.name >= ' ' AND A.blogid = {$blogid})
							OR (A.entry={$r_id} AND A.tag=B.id AND B.name >= ' ')
							GROUP BY A.tag
							HAVING tagcount > 1");

	// 보람말 고리 유무 및 보람말 고리 갯수 
		if ($data['tagView'] == 1) {
			$r_tagname = "[보람말 고리:";
			$j = 0;

  		foreach($r_row as $r_result) {
				if ($j == $data['tagCount'])
					break;
				else if ($j) $r_tagname.='/';
				$j = ($data['tagCount'] == 100) ? 1 : $j;
				$modified_result = str_replace(' ', '%20', $r_result[1]);
				$r_tagname .= "<a href=\"{$blogURL}/tag/{$modified_result}\">{$r_result[1]}</a>";
				$j++;
			}
			$r_tagname .= ']';
		} else {
			$r_tagname = '';
		}

	  $r_txt = ($result[1]);
	  $tagLink = ($blog['usesloganOnPost']?"entry/{$result[2]}":$result[0]);
	  if ($data['commentView'] == 1) {
		  $repComment = ($result[4]) ? "<span class=\"c_cnt\">({$result[4]})</span>":"";
		} else 
			$repComment = "";
		
		$k = ($i-1)*36;
		$rankicon_path = $data['rankIconPath'] == 'http://' || empty($data['rankIconPath']) ? $pluginURL.'/icon/rank.png' : $data['rankIconPath'].'/rank.png';
		$rankicon = ($data['rankIcon'] == 1)?" style=\"background:url({$rankicon_path}) no-repeat 0px -{$k}px;padding-left:13px;\"":'';

   	$tagrelation .= "<li {$rankicon}><a href=\"{$blogURL}/{$tagLink}\">" . htmlspecialchars(UTF8::lessenAsEm($r_txt, $data['cutString'], '…')) . "</a> {$repComment} {$r_tagname}</li>";
   	
  }   


  if (is_null($r_id)) {
  	$tagrelation .= '<li>이 글의 보람말과 얽힌 글이 없습니다.</li>';
  }
  else {
  	if ($data['tagComment'] == 1) {
	  	$tagrelation .= '<br/>* 보람말 고리란? 다른 글이 이 글에 쓰인 어떤 보람말과 얽혔는지 보여 주는 고리.';
  	}
  }

  $tagrelation .= "</ul>" . $data['tagFooter'];
 }

 return $tagrelation; 
}

function tagRelationCfg($data){
	$cfg = setting::fetchConfigVal($data);
	return true;
}
?>